//========================================================================// 
//    The Nomad-Head-System-Project                                                   
//    by                                                                     
//    Rytta Communications Inc.                                           
//    (c) Version 0.11. March 2010                                         
//                                                                          
//========================================================================// 
//    audioReader11.cpp	(ex.audioReader10.cpp)                                                           
//    -----------------
//                                                              
//    begin        : Monday 08. March 14.45:00 GMT 2010                          
//    copyright    : (C) 2003/2006/2009/2010 by  s.morf                                    
//    email        : stevenmorf@bluewin.ch                                   
//    compile with 
//    USB-SerialCom: g++ audioReader11.cpp -o audioReader11 
//    run          : ./audioReader11
//
//    ATTENTION: before start in this folder:
//               on CONSOLE: export PATH=$PATH:/usr/lib/festival";
//                                                    
/************************************************************************** 
//     THIS PROGRAMM IS UNDER THE GNU-LICENCE                              
/***************************************************************************  
    This program is free software; you can redistribute it and/or modify    
it under the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your option) any
later version.                                                                
                                             
****************************************************************************************************
NOTES: Version 0.11. into /root/Desktop/NomadHeadSystems/festival/

08.03. - interductions to communicate (Reader) from the Quad with USB-RS232-Adapter-Cable.
         - this prog read the datas and via FESTIVAL make the sound
         - no Sender
       - compile original ok
       - festival-test with:
         1) export PATH=$PATH:/usr/lib/festival                                            
         2) echo "hello"|festival --tts
         3) festival letter.txt --tts
       - runs ok
09.03. - rs232-port on /dev/ ttyUSB0
       - entwicklungen:
         - on laptop:
           - rs232 receiveDatas  
         - 1.OnlineTests only rs232
             - here NOK sofortiger Abbruch
               - vermutlich wegen fehlenden Input
       - fehlersuche:
         - also gem.NHS -> Exit == 10    
       - 2.OnlineTest only rs232
           - waiting on inputs ok
           - exit with <10>    ok
           - inputs <8> & <10>     ok
           - input sehr unuebersichtlich   
       - etliche verbesserungen
       - 3.OnlineTest OK rs232 
       - now einbau zeitsperre in quad for inputs waehrend laptop sound abspielt
         - basics = difftime.c
       - 1.OnlineTest mit festival and difftime
           - fehler bei : automatical -> const char *festivalPATH = "export PATH=$PATH:/usr/lib/festival";
             - and on main() system(festivalPATH);
           - ergebnisse: for quad difftime == 2 secounds wait
           - ergebnisse: festival with letter.txt 
             - run OK
       - versuche mit zeitsperre on Quad NOK
       - weitere OnlineTest mit wavplay
         - inputs 1 - 4
         - inputs 5 festival
       - SOUND RUN OK
       - here ev. versuche mit audacity for new sounds
         - z.Z. nicht moeglich -> keine ahnung wie das geht
           - um cd-audio abzuspielen erst von cd auf desktop kopieren (*.wav)
             - dann kann man das abspielen
10.03. - beschraenke mich auf festival
       - entwicklung von 5 lettertext.txt for festival
         - 1 "Hello, i am Nomad" == letter1.txt
         - 2 "oooh, yeah"        == letter2.txt
         - 3 "tschindaradaBumps" == letter3.txt
         - 4 "FAILURE"           == letter4.txt
         - 5 "EXIT"              == letter5.txt
       - 1. OnlineVersuch mit Quad & Laptop: 
            - Run OK Festival  OK
11.03. - einbau von audioWriter0207.cpp ex. audioWriter11.cpp
         - into NHS0207
         - compile ok
       - 1.OnlineTest with this stuff
           -1) starting < 1 > hello i am Nomad
           -2) EXIT     < 5 > sound, and all stuff exit
       - no. 1 OK
       - no. 2 NOK NO EXIT
       - into NHS0207 into while ESC
         - sound < 5 >  OK
         - Exit  < 10 > OK
       - into redBallTracking0207.cpp
         no.2 nicht angsprungen
         no.3 OK
       - now tests with servos  
       - run ok after Akku troubles
         - da dass system fast autonom handelt
           - no.2 und no. 3 werden abundzu angesprungen
       - fuer heute reichts  
 

----------------------------------------------------------------------------------------------------
NOTES: version 0.1.0.
12.11. - da es mir im augenblick an motivation fehlt
         - here einbau von einigen wav-files aus /AUDIO
           - dann testing mit quad  
       - 1.onlinetests mit sound: ok
           - alle 4 sounds sehr schnell hoerbar
             - auch in head
             - serialConnections ok 
13.11. - TEXT_TO_SPEECH with Festival
         - on Quad OK
         - on Laptop after troubles OK  
       - 1.versuche mit audioReader and festival
         - if inputs = 5 then festival 
           with system("festival --tts letter.txt");
       - run OK    
 


References:
under / usr
7.12.2006 = wavplay & wavrec - apps

=> copy from PC90 OOK

- wavplay & wavrec on folder usr/X11R6/bin

under /Develop/The_Nomad_Project/Sound/SoundWaves/
play 1: (standAllone) wavplay testwhale2.wav == OK
play 2: with gtkSpect63.c == ./gtkSpect3     == OK

audio-play with wavplay = ./wavplay bloop.wav OK
audio-rec with wavrec == ?
 lautsprecher ausgang on Laptop -> kopfhoehrerSymbol rechts neben USB-Port
****************************************************************************************************

REFERENCES:
   1) Serial Com:
      - mit / ohne Webcams: usbPort = /dev/ttyUSB0
      - with
        - 9600 BAUD, no parity, 8 data-bits and 1 stop bit
          - gem. BS2 Controller-DokuBook page 159 und ff. with DEBUGIN (at BS2)

*****************************************************************************
Ergebnisse linux:
- Command: 1
- SendData: 1
- SendDataString: 1
- Communications: Sender: 1
- Sender is closed
- Now in READER
In[0]: 5
Res: 1
Input: 5
Commr: 1
Inputs: 5
 OK     Reader is Closed
Ergebnisse PropDevBoard
- reiceive 49 as ascii == "1"
- if input == 49 then blue leds ON
                 then send "5" for acknoledge
== VERRY OK   
****************************************************************************/ 

#include<iostream>

#include <math.h>

// C-Stuff for RS232
#include <stdio.h>
#include <stdlib.h>

#include <fcntl.h> 
#include <string.h> 
#include <ctype.h> 

#include <setjmp.h> 
#include <termios.h> 
#include <unistd.h> 
#include <sys/signal.h> 
#include <sys/types.h> 
#include <errno.h> 
#include "curses.h"      
#include <ctype.h>
#include <sys/io.h> 

#include <sys/stat.h>

#include <time.h>

#include <string.h>
#include <sstream>
 
using namespace std;

#define _POSIX_SOURCE 1  	    // POSIX compliant source  

// new for communications 
#define BAUDRATE_LAPTOP   B9600   // baudrate settings for commands mots                                 
#define MODEMDEVICE_LAPTOP "/dev/ttyUSB0"  // on Laptop  

#define MAXTOKLEN 255  // for tokenizer
#define BUFLEN 255
#define S_MAXTOKLEN 8

struct termios oldtio,newtio, options; 

int fw_laptop;     // w=write 
int fr_laptop;     // r=read
int res;
int rescommand;
int s_len;

char combuf[255]; 
char buffer[BUFLEN];
char buf[255];
char s_buffer[BUFLEN];

int inputs;

// Muss so sein, sonst fehler bei system(init_1);
// in main 
const char *init_1 = "chmod a+rw /dev/ttyUSB0";  // on laptop  

// festival export PATH
const char *festivalPATH = "export PATH=$PATH:/usr/lib/festival";
 
// noch offen
char *sendDataStr;
char *recDataStr;
const char *exitString = "10";

char sendData[12];  // for umwandlung int to string with sprintf
const char *sendEOF = ("\r");
const char *sendEOFCR = ("/r");

//char buffer [50];  // example bei sprintf
int n; 
int exits;
int antw; // for output
int i;    // counter

bool bool_doNothing;

bool bool_Go;
bool bool_Done;
bool bool_ReaderDone;
bool bool_SenderDone;
bool bool_Init;

// new sequences
int state;
int oldState;
//int remote_cnt;

//int cnt_1;
//int cnt;
//int comDoneInt = 5;

bool comDone;

// from opencv
bool quit;
bool done;

// for timing
time_t anfang,ende;

/*************************************************************************** 
* Don't forget to give the appropriate serial ports the right permissions  *
* (e. g.: chmod a+rw /dev/ttyS0)!                                          *
* baudrate settings are defined in <asm/termbits.h>, which is              *       
* included by <termios.h>   ==  system(init_1);                            *  
**************************************************************************** 
/*** from conio.h *********************************************************/

void gotoxy(int x, int y) { printf("\033[%d;%dH", y, x); fflush(stdout); }
void clrscr(void)         { printf("\033[H\033[J");      fflush(stdout); }

// delay (nnn)
void delay(long millisek)
{
   int mikrosek = millisek*1000;
   struct timeval  timeout;

   timeout.tv_sec  = mikrosek / 1000000L;
   timeout.tv_usec = mikrosek % 1000000L;
   select(0, NULL, NULL, NULL, &timeout);
}
/**********************************************************************************************/
int Sender()
  {
     printf("Communications: Sender: %s\n",sendDataStr); 

     fw_laptop = open(MODEMDEVICE_LAPTOP, O_WRONLY | O_NOCTTY );        // old O_RDWR 
     if(fw_laptop <0)
        {
           perror(MODEMDEVICE_LAPTOP);
           printf("cannot open ttyUSB0");         
           
           exit(-1); 
        }
     tcgetattr(fw_laptop,&oldtio);                // save current serial port settings 
     bzero(&newtio,sizeof(options));        // clear struct for new port settings 

     fcntl(fw_laptop, F_SETFL,0);
     if(tcgetattr(fw_laptop, &options) != 0) return(-1);
     cfsetspeed(&options,B9600); 
     /*setze Optionen */
      
     options.c_cflag &= ~PARENB;  // NO PARITYBIT
     options.c_cflag &= ~CSTOPB;  // 1 STOPPBIT
     options.c_cflag &= ~CSIZE;   // 8 DATENBIT 
     options.c_cflag |= CS8;
     options.c_cflag |= (CLOCAL | CREAD);  // CD-SIGNAL IGNORE
     // kein echo, keine steuerzeichen, keine interrupts
     
     options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
     
     options.c_oflag &= ~OPOST;  // SETZE RAW-INPUT
     
     options.c_cc[VTIME]  = 10;    /* TIMEOUT 10 SEKUNDEN */ 
     options.c_cc[VMIN]  = 0;      /* wait auf min. 0 zeichen old blocking read  until 1 character arrives */ 
  
     // now clean the modem line and activate the settings for the port  
     tcflush(fw_laptop, TCIFLUSH);
  
     if(tcsetattr(fw_laptop,TCSAFLUSH, &options) != 0) return (-1); 
     
     write(fw_laptop,sendDataStr,s_len);  // len: old 2
        
     /* restore the old port settings */
     
     tcsetattr(fw_laptop,TCSANOW,&oldtio); 
     close(fw_laptop);
     
     printf("Sender is closed\n");
     
     bool_SenderDone = false;
           
  } // end Sender  


/************************************************************************************************/ 
int SoundControl()
  {
     if(inputs == 1)
        {
           system("festival --tts letter1.txt"); 
        }
     if(inputs == 2)
        {
           system("festival --tts letter2.txt"); 
        }
     if(inputs == 3)
        {
           system("festival --tts letter3.txt"); 
        }
     if(inputs == 4)
        {
           system("festival --tts letter4.txt");
        }  
     if(inputs == 5)
        {
           system("festival --tts letter5.txt");        
        }  
        
     printf("Festival Text_to_Speech is Done\n");

     if(inputs > 0)
        {
           //  gotoxy(1,14);
           printf("\nSoundCommand: %d \n",inputs);
/*                  
           n = sprintf (sendData, "%d ", antw);
           // printf ("[%s] is a %d char long string\n",sendData,n);
                   
           printf("SendData: %s\n",sendData); 
           
           sendDataStr = (char *)malloc(strlen(sendData));  
           strcpy(sendDataStr,sendData); 
           
           s_len = strlen(sendEOF); 
                 
           strncat(sendDataStr,sendEOF,s_len); 
                 
           s_len = strlen(sendDataStr); 
           printf("S_Len: %d\n",s_len); 
           printf("SendDataString: %s\n",sendDataStr);

           gotoxy(12,2);
           printf("        ");
*/
        }   
/*
           else
              {  
                 comDone = true; 
                 clrscr();
                 gotoxy(1,1);
                 printf("Back to the Clip... \n");
              }   
*/
      printf("SoundControl is Done\n");
  }
/***************************************************************************************************/
int Reader()
  {
     int x;  
     printf("Now in READER\n");

     fr_laptop = open(MODEMDEVICE_LAPTOP, O_RDONLY | O_NOCTTY );
     if(fr_laptop <0)
        {
           perror(MODEMDEVICE_LAPTOP);
           printf("cannot open ttyUSB0");         
           exit(-1); 
        }
     
     tcgetattr(fr_laptop,&oldtio);          // save current serial port settings 
     bzero(&newtio,sizeof(options));      // clear struct for new port settings 

     fcntl(fr_laptop, F_SETFL,0);
     
     if(tcgetattr(fr_laptop, &options) != 0) return(-1);

     cfsetspeed(&options,B9600); 
     /*setze Optionen */
     
     options.c_cflag &= ~PARENB;  // NO PARITYBIT
     options.c_cflag &= ~CSTOPB;  // 1 STOPPBIT
     options.c_cflag &= ~CSIZE;   // 8 DATENBIT 
     options.c_cflag |= CS8;
     options.c_cflag |= (CLOCAL | CREAD);  // CD-SIGNAL IGNORE
 
     
     options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
     
     options.c_oflag &= ~OPOST;  // SETZE RAW-INPUT
     
     options.c_cc[VTIME]  = 10;    /* TIMEOUT 10 SEKUNDEN */ 
     options.c_cc[VMIN]  = 0;      /* wait auf min. 0 zeichen old blocking read  until 1 character arrives */ 
     
     // now clean the modem line and activate the settings for the port  
     tcflush(fr_laptop, TCIFLUSH);
  
     if(tcsetattr(fr_laptop,TCSAFLUSH, &options) != 0) return (-1); 
      
     printf("Now Read\n"); 
     
     comDone = false;

     while( !comDone)
        {  
           res = read(fr_laptop,buf,255);
           buf[res]=0;                     /* set end of string, so we can printf */
            
         //  printf("In[%d]: %s\n",i,buf); // printf(":%s:%d\n", buf, res); 
         //  printf("Res: %d\n",res);

           rescommand = res;
         //  printf("CommandoBuf: %s\n",buf);
         //  printf("Commr: %d\n",rescommand);

           inputs = atoi(buf);
           printf("Inputs: %d\n",inputs);

           if(inputs > 0)
              {
                 comDone = true;

                //  Sender();

              } 
           if(inputs == 10)
              {
                 comDone = true; 
                 done    = true; 
              }
           if(inputs == 0)
              {
                 comDone = false;
                 printf("Waiting for Input\n"); 
              }
        }
        
     /* restore the old port settings */
     tcsetattr(fr_laptop,TCSANOW,&oldtio); 
     
     close(fr_laptop);
     printf("Reader is Closed\n");

  }

/*** main *****************************************************************************************/
int main()
  {
     done = false;
     comDone = false;

     // starting for festival
     // z.Z. FEHLERHAFT MUSS MANUELL GESTARTET WERDEN
     system(festivalPATH);
     
     // zusatz ev. for festival      
     state = 0;
     oldState = state; 
 
     system(init_1);    // init_1 =  "chmod a+rw /dev/ttyUSB0";  
     
     // now into While-Loop
     while(!done)
        {
           comDone = false; 

           printf("Into Reader\n");
           
           Reader();

           SoundControl();
         
        }  // end While
     
     // clrscr();
     printf("END and bye bye....\n"); 
     return 0;
  } // end main
/**************************************************************************************************/

