{
   The NomadHead-System - Project                
   by
   Rytta Communications Inc.                  
   (c) Version 0.15. March 2010
   NEWEST VERSION: erstellt in propTool 01.03.2010

   TESTPROGRAMM FUER NOMAD-HEAD-SYSTEM 
   ***************************************************************************************
   
   NomadHeadTestSystem_15.spin ( NomadHeadTestSystem_14.spin )
   ---------------------------
   begin       : Monday 01. March 2010 10.15:00 GMT 2010
   copyright   : (c) 2003, 2006, 2009, 2010 by s.morf
   email       : stevenmorf@bluewin.ch
   SpinProgramm:

   For         : SerialControl from Linux to the PropellerProfessionalDevelopmentBoard
                 PPDB 
                 controling:
                 - 2 x CamHeadServos
                 - 3 x HeadSystemServos  with 3DOF (3-Servos)
                 - 2 x WingletServos
                 - 1 x PingDistanceMeter in millimeter
                 
   With        : NomadHeadSystem0400.cpp dd. 22.12.2009
   With        : nomadHeadSystem0200.cpp dd. 31.01.2010 (experimental)
   With        : nomadHeadSystem0204.cpp dd. 20.02.2010 (body (head) + RedBall)
   With        : nomadHeadSystem0205.cpp dd. 23.02.2010 (simBehavior, + body (head) + redBall)
   With        : nomadHeadSystem0206.cpp dd. 01.03.2010 ( simBehavior + body (head) + redBall
                                                          + PingDistance in mm )         
   ****************************************************************************************
   NOTES:
   03.09. - SoftWare-Development with PPDB:
            - Serial Communications with the LinuxSystem
            - ServoControl
              - 2 x CamHeadServos
              - 3 x HeadServos ( 3 DOF )
          - Arbeiten ss. References von 2./3.Sept.
          - 1) anpassungen PanTilt
               RollServo Center 1_600
               TurnServo Center 1_480
            2) umbenamsung: ports ohne zahl                  
          - compile OK
          - 1. Online Test OK with einzel Center OK
               - TestValues:
                 - RollServo:
                   - max. Left  : 21_800
                   - Center     : 21_600
                   - min. Right : 21_400
                 - TurnServo:
                   - Left       :~ 41_280
                   - Center     :~ 41_480
                   - Right      :~ 41_680
                 * -> ~ kann erst getestet werden wenn ganzes System zusammenArbeitet
                 - SingleCenter:
                   - RollCenter  : 102 OK
                   - TurnCenter  : 104 OK
          - Run OK
          - 1.Versuch mit altem Servo ausgebaut
              -  Center    == sehr starkes Zittern
              -  Movements ==
          - mit neuem servo das gleiche
          - anderes Servo von hinteren tisch genommen
            - testing with Servo32_Demo und Nick servoPin                   
              - run OK
          - TESTS mit verry new servo
          - mit allen Servos zusammen OK
          - now mech umbauten
            - und anpassungen mech Art.
          - 1.OnlineTest NickServoModule
              - after umbauten:
                - 1.Run OK on linux up statt down
          - Run OK
            - Values:
              UP      : max. 31_600
              Center  : 31_400     
              Down    : min. 31_100 -> 31_150 -> 31_200
          - Run OK
   04.09. - 1.OnlineTest bevor umbau demontage
              - PanTiltServos  : Roll- Turn OK , SingleCenter OK
              - NickServoModule: OK              
                - Center Nick  : OK
          - demontage nick ok
          - pantilt online:
          - prov. einbau nickservomodule:
            -> new center turnServo 41_400
               - onlineTest center turn ok
          - testing prov.einbau nickservo ok
          - now montage mit allen laufenden servos NICK
            - 1) nickServo eingebaut und alles befestigt
            - 2) servoTeller und schwenkarm prov.montiert
                 - onlineTests Nick ok
                   - !! init starting movesments ??? unwirkuerlich
            - 3) servoteller & schwenkarm fest eingebaut
            - 4) GrundPlatte Head fest eingebaut
            - 1.OnlineTest alles eingebaut:
                - Init        : OK
                - Center      : OK
                - RollServo   : OK
                - TurnServo   : OK
                - NickServo   : OK
                - SingleCenter: OK
            - 2.OnlineTest (FunktionsTest)
                - init ok
05.09. - 1.OnlineTest:  a) with RoboterHeadGluiControl10.cpp
           - Functions:
             - init OK,
             - Movements: OK
             - SingleCenter, AllCenter OK
       - 2.OnlineTests: ServoValues:
           - RollServo:
             - Left  :  21_700 ok, 21_750 ok, 21_800 ok (200)
             - Center:  21_600 ok
             - Right :  21_500 ok, 21_450 ok, 21_400 ok (200)
           - TurnServo:
             - Left  :  41_300 ok, 21_200 ok (200) ca. 45 deg 
             - Center:  41_400
             - Right :  41_600 ok (200) ca. 45 deg
           - NickServo:
             - Up    :  31_500 ok, 31_600 ok (200)
             - Center:  31_400
             - Down  :  31_200 ok    (200)
           - SingleCenter OK  
       - 3.OnlineTests with NomadHead: with cvRobot2CamHeadGluiControl10.cpp
           - CamServos with WebCams:
             - Functions: left / right / augenhoehlen OK
             - ServoValues:
               - Left  :  11_400 ok, min. 11_250 -> augenhoehle (250) 
               - Center:  11_500                
               - Right :  11_600 ok, max. 11_750 -> augenhoehle (250)
             (**) WebCams muessen beim einsetzen auf die Servos quasi kalibriert werden
                  ohne min.max. ca. 130 to 150 moeglich
       - Run OK           
08.09. - 1,OnlineVersuche mit 3DOF-Servo-System und montierten NomadHead
           - mit ServoVerlaengerungsKabel
           - ohne Webcams aber mit CamServos:
             - 1) FunktionsTests:
                  - Ergebnisse: 1.versuche OK
                    - auf jede Seite 50 ServoSteps OK
                    - CamServo : soweit moeglich OK
                    - NickServo: Init and Center OK
                    - RollServo: nur klein       OK
                    - TurnServo:                 OK
                  - erkenntnisse:
                    - 3DOF-Servo-System kann Head halten (init & nothing todo)
                    - Head guckt gerade aus
                    - Servos Brummen aber ok
       - 1.OnlineVersuche mit 3DOF-ServoSystem und montierten NomadHead
           - mit ServoVerlaengerungsKabel
           - mit 2xWebCams und mit CamServos
           - FunktionsTest:
             - bei NickServo UP bei 21_490 guck gerade aus kein brummen
             - camservo left   11_300
                        center 11_500
                        right  11_700
                        
             - rollservo left   21_700    muss i.A.sehr klein sein
                         Center 21_600
                         right  21_500    da noch kein podest

             - nickservo Up     31_600 noch mehr moeglich
                         Center 31_400
                         Down   31_350 stoesst auf tischplatte

             - turnservo left   41_200 ok
                         center 41_400
                         right  41_600 ok
       - todos: - mech.Probleme mit ausleger von RollServo
                  schraube ausgebrochen
                  gehaeuse von rollServo muss auf platte fixiert werden
                  sonst kippt das system nach vorne
       - Loesung: - schraube in bodenplatte -> haelt Gehaeuse RollServo auf Platte
                  - Ausleger wieder neu befestigt
                  - now only all Servos init und center
       - Init & Center OK
09.09. - 1.OnlineTest mit RobotHeadGluiControl10.cpp ohne Webcams aber mit CamServos
           - FunktionsTest after Umbau
             - Init -> Head schwebt -> servo brummt
             - camServo left/right, SingleCenter OK  (je 100)
             - nickServo Up/Down,   SingleCenter OK  (je 100)
             - rollServo left/right SingleCenter OK  (100/50) wegen fehl.podest
             - turnServo left/right SingleCenter OK  (je 100)
       - 1.OnlineTest mit cvRobot2CamHeadGluiControll10.cpp with WebCams und CamServos
           - FunktionsTest OK
             - Movements wie oben OK servoBrummen
             - WebCam images OK seitenrichtig
       - versuche wegen ServoBrummen
         - which Servo             vermutlich RollServo
           - not brummen at value: if rollServo left 2x -> then Center
                                   -> at 31_420 / 31_430
10.09. - gestern mit yellowBox prov.Podest erstellt
       - today:
         - 1) OnlineTests: wegen Init -> Head schwebt and guckt gerade aus
              - servoValues anpassen
                - Init and Center:
                - ergebnisse:
                - Init mit uspsruenglichen Prog und
                  Schaumstoff unterlage soweit ok
                  - unterlage kann leicht weggezogen werden
                  - nickServo-Value for Init OK
                    aka 1_400 31_400 OK
                  - i.A. bleibts so wie es ist  
         - 2) ServoBrummen auf die Spur kommen
              - all Servos testing:
              - ergebnisse:
         - onlineTests mit Podest
           - CamServo Turns OK
           - TurnServo left/right (ja 200) OK
           - NickServo UP   + 31_600
                       Down - 31_250 -> vorderer Teil der grundPlatte kommt in die Quere
           - RollServo Left:  21_720    linker Teil der grundPlatte kommt in die Quere
                       Right: 21_450 OK
         - urploetzlich Linux Absturz - BLUE SCREEN
         - OnlineTests Init und gerade ausgucken
           - verbessertes Init guckt gerade aus:
             - RollServo (left): 21_660  -> 1_660
             - NickServo (UP):   31_460  -> 1_460
        - einbau und changing
          - init OK von hinten siehts gut aus
          - Linux Prog:
            - ohne webcams OK anpassungen ok
            - mit  webcams OK anpassungen ok
        - now with linux hardware -> lautsprecher Tests und konfektionierung
          - Lautsprecher OK -> Sound OK
11.09. - umbauten:
         - hardware maessig:
           - 1) BodenPlatte angepasst
                - BodenPlatte vorne und links vorallem kuerzen ev. rechts auch wegen symetrie
                - Bodenplatte mit schrauben befestigt
           - 2) Einbau Sensoren
                - einbau von Sensoren into KammHead
                  - 1) prov. compile ok
                  - 2) BS2-Debug output soweit OK
                       OUTPUT: $2:15:27:
                  -> soweit OK
         - 1.OnlineTest mit LinuxSystem at sensorRobotSerialComm11.cpp
             - on BS2 comm to linux on usb OK
             - on Linux with usb OK ( </dev/ttyUSB1> -> MODEMDEVICE_BS2
         - RUN OK
         - einbau OK
         - OnlineTest Sensoren eingebaut OK
         - einbau von WebCams OK
         - einbau von Head into 3DOF_Servo-System OK
        - OnlineTest OK Value OK
        - einbau Head into 3DOF-ServoSystem OK
          - WebCam Test ok
        - anschluss der servos: ok
        - 1.onlinetest  with RobotHeadGluiControl19.cpp
            - init OK, SingleCenter OK
            - nickservo UP    max  31_650
            - nickservo Down  min: 31_250
            - rollservo left  max  21_750
            - rollservo right min  21_500  irgendwo knackte es
            - turnservo left  min  41_200  ca. 45 deg
            - turnservo right max  41_600
        - 2.OnlineTest with  cvRobot2CamHeadGluiControll10.cpp with WebCams und CamServos
            - WebCams:
            - camservo left:   11_300 - 200 steps ok
            - camservo right:  11_700   ok
              - rechte webcam musste neu eingesetzt werden into servo
                - sieht teil (gelb) HahnenKamm
                - nach manueller justierung rightCam OK
                  - kurztest
                    left:   ll_300 besser 11_350
                    right:  11_700 ok  
                - endtest fuer heute OK
13.09. - einbau der hinteren HeadSchale (*)
         - 1.OnlineVersuch mit beiden Progs
             - WebCams Images OK
             - CamServos OK
             - Init:
               (*) = schale ist hinten zu tief lang
               MUSS ZUGESCHNITTEN WERDEN
               - prov. NickServo Init 1_400 statt 1_460
                 - nickservo Down at 31_400 == NickCenter                  
                   - 1_400
         - 1.mal OK
14.09. - hintere HeadSchale verkuerzt. OK
       - einbau hintere HeadSchale:
         - ergebnis: OK
       - 1.OnlineTest mit allen Zubehoer:
           - FunktionsTest (1):
             - NickServo INIT neu einstellen:
             - INIT: testen  -> im augenblick so lassen
           - FunktionsTest (2):
             - ServoValues with hinterer Schale:
               - rollservo left  max: 21_700   1_700
                           center   : 21_660   1_660
                           right min: 21_600   1_600
          
               - nickservo Up    max: 31_500   1_500              
                           center   : 31_400   1_400
                           Down  min: 31_300   1_300

               - turnservo left  min: 41_200 better 41_250  1_200 (better 1_250)
                           center   : 41_400                1_400
                           right max: 41_600                1_600              
           - FunktionsTest (3):
             - WebCams Images : OK
             - CamServos left   min : 11_350  11_400 (ohne yellow augenhoehle) 
                         center     : 11_500  1_500             
                         right  max : 11_650  1_650
           - 1.FunktionsTests Board and Servos OK
           - Zusaetzliches Plastik-Podest erstellt
             - steht jetzt wesentlich hoeher
           - 2.FunktionsTests mit Podest OK
17.09. - 1.Gesamt-OnlineTest:
           - ServoValues:
             - camServos:
               - left   min.:  11_350  11_400 to big -> augenhoehle   
               - center     :  11_500
               - right  max :  11_650
             - MUST BE ADUJSTED
             - rollServo:
               - left   max.: 21_750 -> wirkl.max.Wert stoesst dann auf Podest 
               - Center     : 21_660    schon ok
               - right  min : 21_550 -> stoesst noch nicht an Podest aber der symetrie zu liebe
             - nickServo:
               - Up     max : 31_600  
               - Center     : 31_400
               - Down:  min : 31_250 -> minimales down wegen podest
             - turnServo:
               - left   min : 41_200
               - Center     : 41_400
               - right  max : 41_600
           - SensorDatas with BS2-Controller OK
18.09. - OnlineKurzTest OK
21.09. - 1.OnlineTest
           - ergebnis:
       - Entwicklung RedTrack-Funktion:
         - Tracking redBall with CamServos             
           - Left:    11_650 -> 1_650 
           - Center:  11_500 -> 1_500
           - Right:   11_350 -> 1_350
       - Changing NickServoCenter: here and on Linux
         - Old (high)         : 1_400 (31_400)
         - New (on whiteBlock): 1_340 (31_340)
22.09. - da komischerweise version 10 in 2 verschiedenen Versionen existiert
         - 1 x mit new NickCenter dieses hier ex.10
         - 1 x ohne new NickCenter
       - dieses Prog version = 11  mit New NickCenter
       - 1.OnlineTest with all Stuff incl. Sensors
           and RedTrack with 2 WebCams
       - Run OK
       - 1.OnlineTest RedTrack with CamServos
           - NOK left statt right
       - 2.OnlineTest RedTrack now soweit OK
           - unter linux noch einige feinarbeiten notwendig
23.09. - weiterentwicklung RedTrack on linux
         - OnlineTests:
           -  erkenntnis: funzzt jetzt langsam
              - startpunkt ball sollte die mitte sein
              - bewegungen sollten gemaechlich erfolgen
                - dann fuers erste ok
24.09. - da dies nicht die gewuenschte reaktion ist
         - neue versuche mit linux redTrack
25.09. - neue versuche mit linux redTrack
         - bei nur 1x maligen aufruf von redtrack bessere ergebnisse
       - 1. OnlineTest with RedTrack OK
26.09. 1.OnlineTest mit NomadHeadSystem0121.cpp
       - and new RedTrackCommunications2.cpp
       - erweitertes ServoTracking
         - es funzzt aber noch viel feinarbeit
27.09. - erweiterungen bei RedTracking & TrackCalc
         - erweitertes ServoTracking bessere (hoffentlich) FallUnterscheidungen
       - 1.OnlineTest NOK
       - SEHR VIELE UNGEREIHMTHEITEN                
28.09. - Anpassungen und FehlerSuche:
         - under Linux
           - Lines vertauscht bad now Korrekt
           - NickDown wrong vorzeichen statt -  old +  now Korrekt
         - under Prop
           - changing NickCenter from 1_340 to 1_400 better run
       - Testings:
         - obenlinks
           turn      soweit ok (little too much)
           nick      ok
         - obenrechts
           turn      soweit ok (little too much)
           nick      ok
         - untenrechts
           turn      soweit ok (little too much)
           nick      with new center 1_400 better Down ok ( ev podest im weg aber soweit ok)
         - untenlinks
           turn      soweit ok (little too much)
           nick      with new center 1_400 better Down ok ( ev. podest im weg aber soweit ok)
29.09. - 1.OnlineTest
           - gucken obs funzzt
             - OK
       - 2. Abfangen von big NickDowns -> collision with Podest
            - testing at UntenLinks/UntenRechts: NickServo 31_274
              - abfangen mit minDownNickServo at 31_280
              - OnlineTests:
                -  da sehr schnell 31_280 zu klein
                   - Versuch mit 31_300 dann wieder nicht in the middle
                     - bleibt bei 31_280    
       - 3. Entwicklung automatic SingleShots on Linux
            - da mit ClickTrack voellig undurchsichtig
              - 2 verschiedene Tracking-Function
                  - 1x mit ServoTrack
                  - 1x ohne ServoTrack
       - On Linux muss RedTracking besonders Verfolgung
         verbessert werden                           
         - OnlineTests: soweit ok
       - 4. on Propeller:
            - Smoother ServoMovements
              - testing with Servo32_Demo
                              unterschied ist: before SERVO.Set
                              -> waitcnt (cnt+125_000)
             - 1.versuch nur mit TurnServo                   
                 - if OK then all
29.09. - NEW NomadHeadTestSystem_12.spin
         - Changings(1):
           - Better CenterAllServos
             - ansteuerung in repeat Loop with steps
           - Better SingleCenter
             - ansteuerung in repeat loop with steps
         - Center are smoother
         - Changeings(2);
           - einbau of waitcnt( waitcnt (cnt+125_000)
             - before Servo.Set....
           - Movements are smoother
         - ONLINETESTS (Linux & Prop)
           - soweit ok, ABGESEHEN VON EINIGEN HEAD VERRENKUNGEN
30.09. - RedTrack- Verfolgung on Linux verbessern (1)
01.10. - RedTrack- Verfolgung on Linux verbessern (2)
         - mit neuem Single- & BlindShot gute Ergebnisse:
         - ruheLageFilter auch gut
         - stepConverter must be better                           
02.10. - RedTrack WeiterEntwicklung
         - stepConverter must be better
           - keine neuen erkenntnisse bleibt bei static 3.56
03.10. - kurzer OnlineTest OK
06.10. - kurzer OnlineTest mit RedTrack OK
10.10. - 1.OnlineTest with NomadHeadSystem0200.cpp
           - and new BodyTrackCommunications1.cpp
       - noch einige probleme aber im grossen und ganzen fuers 1.mal ok
         - fehl. initial MouseClick Rectangle
11.10. - fehler OK
       - 1.OnlineTest mit whole stuff OK
        - einbau von BodyTrack OK
        - 1.OnlineTest-Versuch (1)
          - erkenntnisse:
            - fuer dieses prog OK
13.10. - onlineVersuche mit bodyTrack
         - new statements
         - keine verbesserungen
       - neuer versuch bei TurnServo == statt Lines Angles
         - verry NOK zurueck zur urspruenglichen version 1
14.10. - einzelschritt online-Tests -> uebersteuerung
17.10. - online-versuche mit new 0203 and new BodyTrack v.3
       - 1.OnlineTest with Version 0203 and new BodyTrack Version 3
           - no Mouse, with HeadGestures and CamShift OOK
20.10. - OnlineTest for ServoMovements & Tracking OK           
31.10. - OnlineTest for ServoMovements & Tracking OK
04.11. - 1.OnlineTest with new NomadHeadSystem0300
         - and new HandGesture1
         - and changing old BodyTrack into HeadTrack
         - Run (1) NOK -> no ServosMoves
         - Run (2) - servos-movements ok                   
                   - redTrack OK
                   - HeadTrack OK
                   - HandGesture NOK SegFault
         -> sehr komplexer Fehler -> braucht seine zeit ABBruch
         --> Fehler gefunden OK
05.11. - 1.OnlineTests
           - ServoMovements  OK
           - RedTrack        OK
           - HeadTrack       NOK -> SeqFault
           - HandGestures on/off   Run ok on/off with window ok           
       - sehr eigentuemlicher fehler jetzt durch trick beseitigt
         - handgesture kann erst gestartet werden hand HeadTracking Done
15.11. - onlinetests fuer weiterentwicklungen OK
27.11. - onlinetest  ok
02.12. - SystemUmbauten -> einbau IR.Leds for Wiimote
         - system auf kuchenDose gesetzt demontage & montage
       - 1.onlineTest 1. versuch VERRY NOK NOTHING RUNS
03.12. - neuerlicher Zusammenbau -> troubles kecksdose
       - jetzt inkl. hinterkopf montiert
       - 1.OnlineTests (1)
           - FEHLER:
             - CamServos : NOK Left/Right 
             - RollServos: NOK Left/Right -> sinkt in sich zusammen
             - NickServos: NOK UP nicht moeglich, Down solala
             - TurnServos: NOK Left/Right moeglich sehr zoegerlich
             - NickServo gerade aus bei keksdose = 31_320
       - i.A. ist System NICHT BRAUCHBAR
       - abbau keksdose
       - 2.OnlineTest (2)

       - camServos :  soweit ok
       - RollServos:  (1) einmal gegangen dann fehler
       - NickServos:  UP: NOK DOWN:  ok
       - TurnServos:  Left: OK    Right:  NOK sinkt in sich zusammen
       - 2.test = turnservo left ok center ok
03.12. - kann mit serialPropDevBoard12.cpp testen
         - servo values entsprechen version 0300
         - 1.test ok
04.12. - neubeginn
         - 1.test only 3DOFServoSystem
           - werte gem version 12 OK funnzzt alles
       - montage versuche (1)
         - gem. zettel -> um rechtsdrall auszugleichen
           - rechts einwenig verkanntet
           - 1) alles eingebaut ohne hinterkopf
       - alles montiert inkl. all
       - 1.OnlineTest mit serialPropDevBoard12.cpp OK
       - changings:
         - RollServo: center -> 21_660
                      Right  -> 21_560
       - ONLINETESTS OOOK
05.12. - 1.OnlineTest ob alles funzzt OK
         - ServoMovements: OK
         - BS2-Controller HeadSensoren OK muss aber durch ein Netzteil betrieben werden
06.12. - OnlineTest -> wegen Head kippte waehrend der Nacht um sollte nicht sein
         - ergebnisse:
           - OK -> servoMovements OK
19.12. - NewVersion of NomadHeadSystems 0400
         - 1.OnlineTests VersionsStand: 0300
         - All OK
21.12. - NewVersion of NomadHeadSystem Version 0401 with WiiMote & Nuchuk-Untertuetzung
         - 1.OnlineTests
           - testings here:
             - ServoMovements via Wimote (openCV-Images)
               - NOK
             - manuelle (Quad-keys) ServoControlle:         
               - OK
         - 1.Versuch NOK
             - serialComm Laptop -> Quad NOK
             - Abstuerze Quad OpenCV
         - umbauten fehler bei ttyS1 statt ttyS0
         - 2.test nok
           - serialCom ok
           - WebCamImages opencv NOK
         - on quad umbauten: opencv
         3.OnlineTest und weitere tests NOCH NOK
         - teilweise gehts halbherzig oder gar nicht
22.12. - neubeginn mit neuer Version of NomadHeadSystem V0400 (stand 0300)
       - 1.OnlineTest ohne wiiMote only Quad
         -  ServoMovements   OK
         -  BS2-HeadSensoren OK
       - All OK version 0400
04.01.2010
04.01. - 1.OnlineTest with HeadSensoren
         - all stuff ok inkl. headSensoren & OpenCV & ServoMovements
10.01. - OnlineTest 0300 ok                          
10.01. - 1.OnlineTest 0100 ok basics of sccades         
16.01. - 1.OnlineTest 0101 OK

2010
30.01.2010 - 1.tests mit 2x microServos for Turns WingLets on NomadHeadSystem
               - testing with Servo32_Demo.spin
                 - with boardPin 7 synchron
                 - 1.Test OK          
                   - laufen synchron auch mit verlaengerungen 2x      
            - ServoLage:
              - seitlich linker-Servo und rechterServo == ServoArm rechts
                 Schrift nach Oben "left right"              
30.01. - 1.OnlineTest mit nomadHeadSystem0200.cpp
           - mit angeschlossenen MicroServos aber ohne Spin-Function und ohne Quad-Function
             - --> irgendwo zirpt es ?????
             - Aber sonst OK
       - 2.test keine servos angeschlossen
           - kein Zirpen mehr also liegts vermutlich am nicht benutzten servoPort
             -> microServos -> aber keine funktion
             - OK
31.01. - 1.OnlineTest wegen Zirpen mit Servo32_Demo.spin
           - probleme mit anbringung sehr langer ServoArm
             - provisorisch geloest
           - ergebnisse: OK
             - arme muessen noch kalibriert werden Neutral 1_500
       - Um- & NeuBau: NomadHeadTestSystem12.spin into:
         NomadHeadTestSystem_14.spin
         - einbau der Winglets-MicroServos
           - Basics
             - boardPin         : 09
             - SingleCenter Wing: 105 (serialInput)
             - Running with     : 50_000 (input)
       - umbauten soweit ok
         - boardPin 9
       - mit new cvWebCamGluiControl14.cpp
         - 1. OnlineTest der Winglets-MicroSercvos
         - funzzt so weit
         - aber linker turn not maximal
       - changing Servo32.object min pulse 750 , max pulse 2_250
         - hat 1.gefunzzt dann ploetzlich
           BIG TROUBLES
           - NO SERVO MOVEMENTS
             - akku jetzt aufgeladen und essen
       - after essen weitere versuche
       - 2.OnlineTest recht gut:
         - Ergebnisse WingLets:
           Winglets  Center         :  1_500 ( 51_500 )
           WingLets anheben min.Left:    750 ( 50_750 )
           WingLets senken  max.Right
           - theoretisch -> max.Right: 2_250 ( 52_250 )
           - zum Senken genuegen
                            max.Right: 1_500 ( 51_500 )
01.02. - 1.OnlineTest mit nomadHeadSystem0201.cpp
           - with Winglets and special Servo32.obj
           - only tests ob alles funzzt
             - soweit OK its move up -> noch verbesserungs wuerdig
             - center OK
             - new Servo32.obj with new width 750 - 1500 - 2250 OK
             - akku soweit ok
02.02. - OnlineTests bevor wegen Winglets Demontage des Systems
         - OK alles funktioniert

04.02. - 1.versuche mit Winglets einbau
           - es hat sich herausgestellt,
           - dass UP == max.Right ist.
       - versuche mit Servo32_Demo.spin
       - OnlineTest:
         - Ergebnisse WingLets:
           - Winglets  Center                          : 1_500 ( 51_500 )
           - WingLets anheben UP  max.Right            : 2_250           ( 52_250 )
           - WingLets senken DOWN min.Left: theoretisch:   750 ( 50_750 )
             - zum Senken genuegen                     : 1_500
04.02. - 1.externe onlineVersuche mit winglets und langem ServoArm (rechts)
           - es soll getestet werden ob der servo ueberhaupt im stande ist,
             - das winglet anzuheben, also mehr oder weniger senkrecht zu stellen
               - ergebnisse:
                 1) ohne winglets ok
                 2) kalibrieren -> 1_500 to 750 temp 10
                    - erkenntnisse ServoArm i.A. zu kurz und zu schnell
                 3) - versuch mit l-profile-plastik-verlaengerung
                      - recht erstaunlich laenge ca. 75mm
                        - wird hochgeworfen
                    - theoretisch funzzt jetzt
                 4) - ausleger jetzt 40mm
                    - abstand zu drehpunkt moeglichst kleinhalten   
                      - noch fragen wegen optimaler laenge und
                 5) - neu kalibrierung: Up = 2_250 fuer links rechts     
                      - platzverhaeltnisse:
                        - rechts passt es in das seitenTeil
                          - unterfuettert schaumstoff rest
                        - links spiegelverkehrt
                          - befestigung auf gegenueberliegender seite
07.02. - 1.OnlineTest only HardWare MicroServos
           - mit Servo32_Demo.spin
           - Up   = 2_250
           - Down = 1_500
       - ergebnisse:
         - Drehrichtung stimmt
       - 1.OnlineTest mit cvWebCamGluiControl14.cpp
         - RightTurn must be UP
         - LeftTurn  must be DOWN
       - Ergebnisse:
         - NOK
           - CENTER NOK zu gross
           - DrehRichtung OK
           - UP bis 51_750 -> UP
                bis maxRight = 52_250 --> Down
       - FehlerSuche (1)
         - Center: new 51_300 -> 1_300  OK
         - Right : UP neuer wert = ca. 51_900 - 52_000
       - FehlerSuche (2)
         - Center: AFTER UP -> CENTER -> AUSLEGER VERHACKT SICH
           - black klebband war im Weg -> geloest
       - FehlerSuche (3)
         Up: best UpServoValue: 51_950
         - bei groessern wert senkt sich der winglet wieder -> maximale Auslenkung
       - Erkenntnisse:
         - da maxUP innerhalb von normalen Servo32.obj.
           - width liegt
             - umbau Servo32.obj  minWidth: 1_000 , maxWidth: 2_000
             - umgebaut
       - 1.test mit normalen Servo32.obj
         - OK
08.02. - 1.OnlineTest with only winglets and
           - nomadHeadSystem0201.cpp
           - allg.Test funzzen die winglets mit behavior
             - soweit OK
             - Winglets Moves
             - with all keys
       - RUN OK
       - Now Montage of NHS (1)
09.02. - 1) einbau von vorderSeite KopfSchale auf 3DOF-ServoSystem
            - schrauben noch nicht angezogen
       - 1.OnlineVersuch mit cvWebCamGluiControl14.cpp
           - ev.Troubles with ServoDirections left/right
           - NOK
       - ev. liegts an fehlenden winglets servos
       - prov. einbau von microServos
       - 2.OnlineVersuch:
           - BAD ROLL-SERVO NO MOVEMENTS
           - auch mit anderen externen servo the same troubles
       - 3.versuch mit Servo32_Demo.spin only rollServo p1
           - values from 1_000 to 2_000 = Run OK
           - funzzt auch gewaltig bei diesem System
       - 4.OnlineTest All Movements ok
           - Fehler RollServo = Center is now 1_660 NOT 1_500
10.02. - Montage beider WebCams
         - OK
       - OnlineTest OK  
         - CamServoValues:
           - Center:  1_500
           - Left  :  OK
           - Right :  OK
           - ev. etwas mechanisch justieren
         - Winglets Up/Down OK
         - Troubles with TurnServo
           - CENTER is 1_400 not 1_500
       - Run OK    
11.02. - after einbau HeadSensoren & onlineTest OK
       - Einbau von hinterer KopfSchale mit MicroServos
         - einbau soweit OK
       - 1.ONLINETESTS:  OOK  
         - Allg.        : OK
         - CamServo     : OK          
         - RollServo    : OK
         - NickServo    : OK
         - TurnServo    : OK
         - WingletsServo: OK
       - 1.Test mit Winglets
           - nach einigen abbruechen
             - soweit OK
       - Muss noch intensiver getestet werden ob
         es ueberhaupt sinnvoll ist ????
         - laeuft nicht sehr parallel - aus der bahn ?????
       - 2.test soweit ok
12.02. - 1.ausfuehrlicher ONLINE-TEST (1) with
         - cvWebCamGluiControl14.cpp
         - Allg.Test grundfunktionen:
         - All ServoValues min/max. center:
           - CamServo
             - Left  :  11_250  -> 1_250  OK
             - Center:  11_500  -> 1_500  OK
             - Right :  11_750  -> 1_750  OK
                        
           - RollServo
             - Left  : 21_700  -> 1_700 OK  muss i.A.sehr klein sein
             - Center: 21_660  -> 1_660 OK
             - Right : 21_620  -> 1_620 OK  

             - NickServo
               -  Up    : 31_600 -> 1_600 OK 
               -  Center: 31_400 -> 1_400 OK
               -  Down  : 31_300 -> 1_300 OK

             - TurnServo
               - Left  : 41_000  ca. 45 -> 1_000 OK 
               - Center: 41_400          -> 1_400 OK
               - Right : 41_800  ca. 45 -> 1_800 OK
                              
             - WingLetsServo
               - Up    : 51_950 -> 1_950 OK
               - Center: 51_300 -> 1_300 OK                 
               - Down  : 51_300 -> 1_300 OK
         - RUN OK
         - 1.ONLINE-TEST with nomadHeadSystem0201.cpp & Winglets
         - SOWEIT OK
13.02. - 1.OnlineTest with nomadHeadSystem0202.cpp
           - gucken ob alles funzzt (ohne HeadSensoren)
             - von ServoMovements & Winglets OK
       - Behavior & OpenCV - WeiterEntwicklungen
14.02. - OnlineTests
         - OK
20.02. - with new nomadHeadSystem0204.cpp
         - with HeadTracking & RedBallTracking & Winglets
       - 1.OnlineTest OK
28.02. - 1.Versuche mit internen HeadSensoren
         - Board: sensorHeadTalking1.spin
         - Linux: serialPropDevBoard14.cpp
           - output: $-240:168:325:
NEW VERSION:
01.03. - umbau von version 14 with new Ping-Distance in millimeter
         - with new
           - as test: serialPropDevBoard14.cpp
           - 1.OnlineTest Output == 466 mm
           - Run only Ping OK
       - 1./2.OnlineTest with new headSensor0206(E).cpp at NomadHeadSystem0206.cpp
              - and new NomadHeadTestSystem_15.spinn
       - Run OK
       - umbau Ping Signal red/green on PIN 8
       - demontage HeadSystem
         - Memsic2125 entfernt
       - Montage HeadSystem
       - 1.OnlineTest nach Montage
           - VERRY VERRY NOK ON XP NO COM-PORT
           - restart XP
           - hab vergessen usbCabel into Board now OK
       - Sehr grosse Umstellung
         alle chipPins geaendert
         p0 = camServo0    
         p1 = rollServo1
         p2 = nickServo2
         p3 = turnServo3
         p4 = wingStervo (4)

         p5 = Ping input

         p7 = output blueLed_1 ' ex 14 ledPin
         p8 = output blueLed_2 ' ex 15 ledPin
         
       - 1.OnlineVersuch mit neuem Stuff
         - big troubles
           - with servoMovements on spin
           - with Center         on linux
           - with Ping           on linux

       - komischerweise funzzt diese pinBelegung auch mit Version 14
       - noch viel arbeit
12.03. - FirstStage with extern blueLeds with chipPin7 / 8
         - testing with BLINKTEST_CLOCK.spin OK
         - chipPin 7 wird bei rs232-com geschaltet
         - chipPin 8 wird bei functions-ausfuehrungen + ping geschaltet
       - umgebaut.
       - todo konfektionierung der beiden blueLeds
         - cable & connections
                                             
------------------------------------------------------------------------------------------                      
New Notes dd. 2.March 2010:
---------------------------
NOTES:
02.03. - OnlineTest with all ServoMovements
         with cvWebCamGluiControl14.cpp (opencv + opengl (GLUI))
       - RUN OK -> ServoValues OK, Pin-Belegung OK
       - OnlineTests with NomadHeadSystem0206.cpp
         - verry big Troubles with Linux
           - key < c > on linuxSide NOK
           - key < s > on LinuxSide NOK
           - here -> green PING LED NOT BLINKING DAUERND ON - FAULTS
       - FehlerSuche mit sensorHeadTalking1.spin
         - mit old Pin 5 == NOK
         - mit new Pin 6 == OK -> range_mm with serialPropDevBoard14.cpp
       - 2.OnlineTest only for PING
         - with key < s > im laufenden betrieb OK     
       - 3.OnlineTest with Center < c >
         - ausserhalb von if(AUTO_COLORSLIDER_KEYa == true)
           - OK    
         
References:
-----------
- Pins:
  CamServo  = 0      
  RollServo = 1
  NickServo = 2     
  TurnServo = 3     
  WingServo = 4     

  PING_Pin = 6 -> I/O Pin For PING

  P7 = LED14
  P8 = LED15

CORRECT SERVO-VALUES
--------------------
 
- All ServoValues min/max. center:
  - CamServo
    - Left  : 11_250  -> 1_250  OK
    - Center: 11_500  -> 1_500  OK
    - Right : 11_750  -> 1_750  OK
                        
  - RollServo
    - Left  : 21_700  -> 1_700 OK  
    - Center: 21_660  -> 1_660 OK
    - Right : 21_620  -> 1_620 OK  

  - NickServo
    -  Up    : 31_600 -> 1_600 OK 
    -  Center: 31_400 -> 1_400 OK
    -  Down  : 31_300 -> 1_300 OK

  - TurnServo
    - Left  : 41_000  -> 1_000 OK  -> ca. 45 
    - Center: 41_400  -> 1_400 OK
    - Right : 41_800  -> 1_800 OK  -> ca, 45
                              
  - WingLetsServo
    - Up    : 51_950 -> 1_950 OK
    - Center: 51_300 -> 1_300 OK                 
    - Down  : 51_300 -> 1_300 OK
------------------------------------------------------------------------------------------
PING REFERENCES:
----------------
Interface to Ping))) sensor and measure its ultrasonic travel time.  Measurements can be in units of time or distance.
Each method requires one parameter, Pin, that is the I/O pin that is connected to the Ping)))'s signal line.

Ping: Pin   : P6 with 1k w'stand gem. sensorHeadTalking1.spin

Ping: input : < 1 >

Ping: Outputs
optional LONG  range_cm
LONG  range_mm:
------------------------------------------------------------------------------------------                                 

BIG TROUBLES WITH AKKU  schon wieder no Movements                            
                             
- da minWidth und maxWidth in Servo32.obj ev. die anderen HeadServo beeinflussen oder
  sogar beeintraechtigen
  --> ev. mechanische NeutralStellung WingServos veraendern             
                                                  
                   
            
TODOS: - bei Abschluss einer OpenCV-Funktion
         - Aufruf AllServosCenter: sonst guckt er ins Juhee
                                                            
todos: - ev.Software maessig:
         - bei extremen Roll wackelt der boden also vorsichtig
         
       - aufpassen bei init
         - erst blueLed ON                                         
         - dann Akku ON

               
------------------------------------------------------------------------------------------
DREFERENCES:
                                
    - Center jetzt 1_500 -> guckt gerade aus
      - Erkenntniss: wenn eyecams fest (verklebt) mit den servos
                      verbunden wird.
                      -> bei verbkleben unbedingt testProg laufen lassen
      - Quality of Images into Head:
        - recht gut
          - da jetzt gegen die hellen fenster geguckt wird dunkel
            - ServoTurns:
              - Center    : 1_500
              - max. Left : 1_300            
              - max. Right: 1_700
          - einbau (verkleben) der webcamNocken mit servos
            - dauernder probTest
            - OK eingeklebt -> now waiting for tomrrow
 
          - PropDevBoard + Servos + Webcams + Linux
            - Run OK
              - bei der Rechten-WebCam Center mechanisch einwenig nach rechts drehen
                - sonst wenn nach links beblickt wird kommt augenhoehle in die Quere
                - ev. mechanisch einwenig ausfraesen
            - sonst ok
            - am folgeTage Augenhoehlen ausgefraest
    02.09. - 1.OnlineServoTests for NomadHeadSystem (1)
               with RobotHeadGluiControl10.cpp (no Webcams)
             - 1) testing PanTiltServos
                  - NOK NO Movements
             - 2) tests
                  Turn on p0 OK
                  Roll on p1 NOK
             - mein bloeder fehler: no connection from chipPin to servoPin
           - 2. OnlineTest
                - TurnServo OK da noch NickServo not on place Center ???
                - RollServo jetzt NOT Center now Center SW == 1_600
                  should be mechanical to center
           - Run OK
           - 3.ONLINE-TEST WITH NEW NICK-SERVO-MODULE
             - unter p2 as nick
           - troubles but moves verry special
             - nach fast auseinander nehmen erste movements
               mit p0 center 1_500
               down 11_300
               up   11_700
             - !!!! bei erreichen des zielStandes zuckt es gewaltig
               DA NOCH GENUEGEND SERVOS VORHANDEN UND DAS GANZE
               sowie so neu zusammen gebaut wird
               1) wegen verbindung zu turnservo (dieser auch mech. zentriert wird)
               2) NEUEN SERVO EINBAUEN AUSTAUSCH
                  MONTAGE MUSS SEHR BEHUTSAM GEMACHT WERDEN
                  DARF NICHT VERKANNTEN  
             - soweit ok
03.09. - ueberpruefung Center: RollServo as per PanTiltSystem_10.spin
         - RollServo as Center: 1_600
           - kein mech.Abgleich noetig
03.09. - New SpinProg: NomadHeadTestSystem_10.spin
         - aka Robot2CamHeadControl_10.spin

                                 
-----------------------------------------------------------------------------------------
REFERENCES PAN-TILT-SYSTEM FROM PanTiltSystem_10.spin

   05.08. - 1.OnlineTests und Versuche
            - changing Verkabelung Board only for 2 Servos
              - OK
          - 1.test with 2 servos und cvPanTiltGluiControl10.cpp
            - running = OK
              - Nick -> center Muss angepasswerden bei 1_500 not wagrecht
              - Turn -> ok
            - TROUBLES -> beide (left/right only UP NOT down   OK
            - Kalbibrierung:
              - NickServo0 :    Center:  1_600
                                Up    :  2_000 -> is camservo0 rightturn
                                Down  :  1_200 -> is camservo0 leftturn
              
              - TurnServo1 :    Center:  1_480
                                Left  :  1_000  ca 45 deg
                                Right :  2_000  ca 45 deg
                                
          - changing: Nick -> Center: 1_600                                        
          - Basics: 
            - Servo32-Object mit Min: 1_000, Neutral: 1_500, Max: 2_000
          - NeuEntwicklung PanTilt mit 2 x Servos        
            - new ServoPorts als Servo32-Object
              - einstellung und Kalibrieren (1) OK
             
----------------------------------------------------------------------------------------
REFERENCES NICKSERVOMODUL
                                          
UMBAU GEWINDESTANGE SCHRAEG AUF AUSLEGER NACH UNTEN NEUE LOCH
grundplatte bohrungen neu schraube
schwarze drehteller schraube bohrung ausleger  vergroessern und unterlage scheibe

                   
           down 11_300  up 11_700                 
                    
TODO: RollServo -> center 1_600 or mechanical

References: dd. 18.08.2009
            - under Folder "NewProp_PPDB_Stuff dokus
              - gem. pdf: ist es moeglich
                - Distance-Messer (PING)
                - propPIR -> NOT
                - Memsic 2D-Sensor anzuschliessen                        
                   
moeglichkeiten for board
- multithreading with cogs -> 4 servos == 4 cogs + 1 mainCog
- for linux
  multitreading ???

   - Todos wichtig:
     - das ganze muss sanfter smoothing laufen
     - WebCams muessen vorne beim Body gegen seitliches verrutschen
       gesichert werden, ev. zusaetzlich eine weiche Unterlage

   TROUBLES on OnlineTests:
   - center muessen sanfter laufen
   - Nein on CamServo0  : ruckelt wenn sich andere einzelServo bewegen !!!
   - Nein on RollServo1 : ruckelt mit CamServo0 zusammen wenn einzel Servos bewegt werden

   - IM AUGENBLICK SIND MIR DIE MOVEMENTS ZU SCHNELL
     KANN AUCH SEIN, DASS DAS WEGEN MIN. UND MAX-WERTEN SO IST
        
   References of the Servo32-Object:
   - minVal : 1_000
   - maxVal : 2_000
   - Diff   : 1_000
   - Neutral: 1_500
 
*****************************************************************************************
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  Rx   = 31                            
  Tx   = 30                                 
  baud = 9600

  CamServo  = 0                  ' Set CamServo  on pin0 
  RollServo = 1                  ' Set RollServo on pin1
  NickServo = 2                  ' Set NickServo on pin2
  TurnServo = 3                  ' Set TurnServo on pin3
  WingServo = 4                  ' NEW WingServo on pin4 -> 2x microServos for Winglets

  PING_Pin = 6                   ' INPUT I/O Pin For PING)))

  ' nicht benutzt direktes Set
  ' LED_1 = 7 TO extern LED14            
  ' LED_2 = 8 TO extern LED15
                                 '
  steps      = 1
   
    
OBJ                                              
   Serial : "Extended_FDSerial"
   SERVO  : "Servo32"           ' Servo32 obj or Servo32v3- obj (dann aber anpassen)
   ping   : "Ping"              ' ping-object       
VAR
  BYTE boolStart 
  BYTE x           ' counter
  LONG servoPort   ' var servoPort (0,1,2,3)
  BYTE output      ' SerialOutput  "5"
     
  LONG pulses
  LONG oldCamPulses   
  LONG newCamPulses   
  LONG oldRollPulses  
  LONG newRollPulses  
  LONG oldNickPulses  
  LONG newNickPulses  
  LONG oldTurnPulses  
  LONG newTurnPulses

  LONG oldWingPulses  
  LONG newWingPulses

  ' PING
  LONG  range_cm
  LONG  range_mm
  
  LONG myInput     ' SerialInput   
  
{******************************************************************************************}
PUB Main
      
   Serial.Start(Rx,Tx,0,baud)   
{
   DIRA[0]~~   'set chipPin0 to output   CamServo0
   DIRA[1]~~   'set chipPin1 to output   RollServo1
   DIRA[2]~~   'set chipPin2 to output   NickServo2
   DIRA[3]~~   'set chipPin3 to output   TurnServo3
   DIRA[4]~~   'set chipPin4 to output   WingServo (4)   
}   
   ' debuging Help Leds
   DIRA[7]~~   ' set chipPin7 to output to extern blueLed_1 ex intern LED 14
   DIRA[8]~~   ' set chipPin8 to output to extern blueLed_2 ex intern LED 15
{
   ' PING
   DIRA[6]~    ' set chipPin5 to input  for input PING   
   
   outa[0]~    ' set chipPin0 to LOW CamServo0
   outa[1]~    ' set chipPin1 to LOW RollServo1
   outa[2]~    ' set chipPin2 to LOW NickServo2
   outa[3]~    ' set chipPin3 to LOW TurnServo3
   outa[4]~    ' set chipPin4 to LOW WingServo (4)
}
   outa[7]~    ' set chipPin7 to LOW blueLED 1 ex intern led14     
   outa[8]~    ' set chipPin8 to LOW blueLED 2 ex intern led15
   
     'Preset Servo's you want to use to center position
   SERVO.Set(CamServo, 1_500)   '  
   SERVO.Set(RollServo,1_660)   ' new Head guckt geradeaus gem. PanTilt (old 1_600)= wegen verzahnung muss wagrecht stehen
   SERVO.Set(NickServo,1_400)   ' new Head guckt geradeaus, kinn on whiteBlock old 1_340 
   SERVO.Set(TurnServo,1_400)   ' gem. einbau NickServoModule
   SERVO.SET(WingServo,1_300)   ' old: 1_500)   ' noch kalibrieren

   ' Note: Servo pins that will be used must be preset before running "SERVO.Start".
   '       This is because the I/O direction is set here and is only executed
   '       at the beginning of "SERVO.Start".  Servo pins that aren't used will remain
   '       in their original direction state.

   SERVO.Start                                         'Start Servo handler

   oldCamPulses  := 1_500   '  
   oldRollPulses := 1_660   ' 1_600 head gerade aus guckennew center gem.PanTilt  
   oldNickPulses := 1_400   ' 1_340 head-Kinn on whiteBlock old 1_340  mit HeadSchale
   oldTurnPulses := 1_400   ' new center gem.einbau nickservo
   
   oldWingPulses := 1_300   ' old: 1_500   ' noch kalibrieren  
                                                   
   repeat
     outa[7]~~   'set chipPin7 Led1 HIGH
      
     ' input:= Serial.RxTime(100)  ' byte as ascii
     
     myInput := Serial.rxDec       ' receive bigNumbers as ServoCommands
     waitcnt(clkfreq / 10 + cnt)

     ' EXIT PROGRAMM AND CENTER ALL SERVOS        
     IF myInput == 10
        NewServoCenterAll
        QUIT

     ' PING-SENSOR-HEAD -> distance in millimeter
     IF myInput == 1
        askPing
     
     IF myInput == 100
        NewServoCenterAll   ' Set All Servos to Center  
         
     IF (myInput > 100)  AND (myInput < 106)
        singleServoCenter           'SingleServoCenter
          
     IF myInput > 10000
        servoPorts
        
     outa[7]~                    ' set chipPin7 blueLed 1 LOW 
{****************************************************************************************}
PUB NewServoCenterAll 
   ' CamServo0                                   
   newCamPulses := 1_500
   pulses := 1_500

   outa[8]~~
   IF(newCamPulses > oldCamPulses)
      REPEAT pulses FROM oldCamPulses TO newCamPulses + steps
         waitcnt (cnt+125_000)    
         SERVO.Set(CamServo, pulses)   
      oldCamPulses := newCamPulses
      
   IF(newCamPulses < oldCamPulses)
      REPEAT pulses FROM oldCamPulses TO newCamPulses - steps
         waitcnt (cnt+125_000)    
         SERVO.Set(CamServo, pulses)   
      oldCamPulses := newCamPulses
   outa[8]~
   waitcnt (cnt+125_000)
          
   ' RollServo1
   newRollPulses := 1_660
   pulses := 1_660
   
   outa[8]~~
   IF(newRollPulses > oldRollPulses)
      REPEAT pulses FROM oldRollPulses TO newRollPulses + steps  
         waitcnt (cnt+125_000)    
         SERVO.Set(RollServo, pulses)   
      oldRollPulses := newRollPulses
       
   IF(newRollPulses < oldRollPulses)
      REPEAT pulses FROM oldRollPulses TO newRollPulses - steps
         waitcnt (cnt+125_000)    
         SERVO.Set(RollServo, pulses)  
      oldRollPulses := newRollPulses
   outa[8]~
   waitcnt (cnt+125_000)    

   ' NickServo2
   newNickPulses := 1_400
   pulses := 1_400

   outa[8]~~
   IF(newNickPulses > oldNickPulses)
      REPEAT pulses FROM oldNickPulses TO newNickPulses + steps   
         waitcnt (cnt+125_000)    
         SERVO.Set(NickServo, pulses)    
      oldNickPulses := newNickPulses
      
   IF(newNickPulses < oldNickPulses)
      REPEAT pulses FROM oldNickPulses TO newNickPulses - steps
         waitcnt (cnt+125_000)    
         SERVO.Set(NickServo, pulses)   
      oldNickPulses := newNickPulses

   outa[8]~
   waitcnt (cnt+125_000)    
      
   ' TurnServo3
   newTurnPulses := 1_400
   pulses := 1_400

   outa[8]~~
   IF(newTurnPulses > oldTurnPulses)
      REPEAT pulses FROM oldTurnPulses TO newTurnPulses + steps    
         waitcnt (cnt+125_000)    
         SERVO.Set(TurnServo, pulses) 
      oldTurnPulses := newTurnPulses
       
   IF(newTurnPulses < oldTurnPulses)
      REPEAT pulses FROM oldTurnPulses TO newTurnPulses - steps
         waitcnt (cnt+125_000)     
         SERVO.Set(TurnServo, pulses)    
      oldTurnPulses := newTurnPulses
   outa[8]~

   ' WingServo (4)
   newWingPulses := 1_300  ' old: 1_500
   pulses := 1_300         ' old: 1_500

   outa[8]~~
   IF(newWingPulses > oldWingPulses)
      REPEAT pulses FROM oldWingPulses TO newWingPulses + steps    
         waitcnt (cnt+125_000)    
         SERVO.Set(WingServo, pulses) 
      oldWingPulses := newWingPulses
       
   IF(newWingPulses < oldWingPulses)
      REPEAT pulses FROM oldWingPulses TO newWingPulses - steps
         waitcnt (cnt+125_000)     
         SERVO.Set(WingServo, pulses)    
      oldWingPulses := newWingPulses
   outa[8]~
      
   Serial.str(string("5"))     
   waitcnt(clkfreq / 10 + cnt)  'ev send "5"
   
{****************************************************************************************}
PUB singleServoCenter
   OUTA[8]~~
   IF(myInput == 101)       '(CamServo, 1_500)  
      newCamPulses := 1_500
      pulses := 1_500
      runningCam  
      waitcnt (cnt+125_000)
          
   IF(myInput == 102)        '(RollServo,1_660)
      newRollPulses := 1_660
      pulses := 1_660
      runningRoll                         
      waitcnt (cnt+125_000)    

   IF(myInput == 103)        '(NickServo,1_400)
      newNickPulses := 1_400
      pulses := 1_400
      runningNick
      waitcnt (cnt+125_000)    
      
   IF(myInput == 104)        '(TurnServo,1_400)  
      newTurnPulses := 1_400
      pulses := 1_400
      runningTurn
      waitcnt (cnt+125_000)

   IF(myInput == 105)        '(WingServo,1_300) old: 1_500  
      newWingPulses := 1_300 ' old: 1_500
      pulses := 1_300        ' old: 1_500
      runningWing
      waitcnt (cnt+125_000)
     
   Serial.str(string("5"))     
   waitcnt(clkfreq / 10 + cnt)
   outa[8]~

{*****************************************************************************************}           
PUB servoPorts
   
   servoPort := myInput / 10000
   pulses    := myInput -(servoPort * 10000)

   IF(servoPort == 1) 
       newCamPulses := pulses
       runningCam
   IF(servoPort == 2) 
       newRollPulses := pulses
       runningRoll
   IF(servoPort == 3) 
       newNickPulses := pulses
       runningNick
   IF(servoPort == 4) 
       newTurnPulses := pulses
       runningTurn
   IF(servoPort == 5) 
       newWingPulses := pulses
       runningWing    

'*** subFunctions ********************************************************
PUB runningCam  ' p0
   outa[8]~~
   IF(newCamPulses > oldCamPulses)
      REPEAT pulses FROM oldCamPulses TO newCamPulses + steps
         waitcnt (cnt+125_000)    
         SERVO.Set(CamServo, pulses)   
         
      oldCamPulses := newCamPulses
   
   IF(newCamPulses < oldCamPulses)
      REPEAT pulses FROM oldCamPulses TO newCamPulses - steps
         waitcnt (cnt+125_000)    
         SERVO.Set(CamServo, pulses)   
          
      oldCamPulses := newCamPulses
   
   Serial.str(string("5"))     
   waitcnt(clkfreq / 10 + cnt)
   outa[8]~
             
PUB runningRoll ' p1
   outa[8]~~
   IF(newRollPulses > oldRollPulses)
      REPEAT pulses FROM oldRollPulses TO newRollPulses + steps  
         waitcnt (cnt+125_000)    
         SERVO.Set(RollServo, pulses)   
          
      oldRollPulses := newRollPulses
       
   IF(newRollPulses < oldRollPulses)
      REPEAT pulses FROM oldRollPulses TO newRollPulses - steps
         waitcnt (cnt+125_000)    
         SERVO.Set(RollServo, pulses)  
         
      oldRollPulses := newRollPulses

   Serial.str(string("5"))     
   waitcnt(clkfreq / 10 + cnt)   
   outa[8]~
   
PUB runningNick ' p2
   outa[8]~~
   IF(newNickPulses > oldNickPulses)
      REPEAT pulses FROM oldNickPulses TO newNickPulses + steps   
         waitcnt (cnt+125_000)    
         SERVO.Set(NickServo, pulses)    
         
      oldNickPulses := newNickPulses
      
   IF(newNickPulses < oldNickPulses)
      REPEAT pulses FROM oldNickPulses TO newNickPulses - steps
         waitcnt (cnt+125_000)    
         SERVO.Set(NickServo, pulses)   
         
      oldNickPulses := newNickPulses

   Serial.str(string("5"))     
   waitcnt(clkfreq / 10 + cnt)
   outa[8]~
    
PUB runningTurn ' p3
   outa[8]~~
   IF(newTurnPulses > oldTurnPulses)
      REPEAT pulses FROM oldTurnPulses TO newTurnPulses + steps    
         waitcnt (cnt+125_000)    
         SERVO.Set(TurnServo, pulses) 
         
      oldTurnPulses := newTurnPulses
       
   IF(newTurnPulses < oldTurnPulses)
      REPEAT pulses FROM oldTurnPulses TO newTurnPulses - steps
         waitcnt (cnt+125_000)     
         SERVO.Set(TurnServo, pulses)    
          
      oldTurnPulses := newTurnPulses
      
   Serial.str(string("5"))     
   waitcnt(clkfreq / 10 + cnt)  'ev send "5"
   outa[8]~

PUB runningWing ' p4
   outa[8]~~
   IF(newWingPulses > oldWingPulses)
      REPEAT pulses FROM oldWingPulses TO newWingPulses + steps    
         waitcnt (cnt+125_000)    
         SERVO.Set(WingServo, pulses) 
         
      oldWingPulses := newWingPulses
       
   IF(newWingPulses < oldWingPulses)
      REPEAT pulses FROM oldWingPulses TO newWingPulses - steps
         waitcnt (cnt+125_000)     
         SERVO.Set(WingServo, pulses)    
          
      oldWingPulses := newWingPulses
      
   Serial.str(string("5"))     
   waitcnt(clkfreq / 10 + cnt)  'ev send "5"
   outa[8]~

PUB askPing
   outa[8]~~
   ' Ping
   'range_cm := ping.Centimeters(PING_Pin)     ' Get Range In Centimeters
   range_mm := ping.Millimeters(PING_Pin)
   waitcnt(clkfreq / 10 + cnt)         
  
   ' serialOutput
   ' Serial.dec(range_cm)
   Serial.dec(range_mm)        ' Ping range_cm  ex 333  
 
   ' Serial.SetDelimiter(13)
   outa[8]~    
{****************************************************************************************}   
 